# Copyright (C) 2009 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)
LOCAL_MODULE := libopenglplugin
LOCAL_LDLIBS := -lGLESv1_CM -llog
LOCAL_LDFLAGS := -Wl,--export-dynamic

LOCAL_ARM_MODE=arm

# We could change files that don't need high performance 
# to thumb mode later...
LOCAL_ARM_MODE := arm

# Removed Wall for now... way too many warnings
LOCAL_CFLAGS := -DLINUX -DANDROID -s -O3 -D__ANDROID__ -D__ARM__ -falign-functions

ifeq ($(TARGET_ARCH_ABI),x86)
LOCAL_CFLAGS := -DLINUX -DANDROID -s -O3 -D__ANDROID__ -falign-functions -DX86
endif

LOCAL_SRC_FILES := ogl/gpuDraw.c \
   ogl/gpuFPS.c \
   ogl/gpuPrim.c \
   ogl/gpuPlugin.c \
   ogl/gpupsemu.c \
   ogl/gpuTexture.c \
   ogl/gte_accuracy.c \
   ogl/gpusoft.c

LOCAL_LDLIBS := -lGLESv1_CM -ldl -llog

include $(BUILD_SHARED_LIBRARY)

