/***************************************************************************
 *   Copyright (C) 2011 by Blade_Arma                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02111-1307 USA.           *
 ***************************************************************************/


#include "gpuExternals.h"
#include "gte_accuracy.h"

//float gteCoords[0x800 * 2][0x800 * 2][2];
float *gteCoords = NULL;

void GPUaddVertex(short sx, short sy, signed long long int fx, signed long long int fy, signed long long int fz)
{
	if(bGteAccuracy)
	{
		if(sx >= -0x800 && sx <= 0x7ff &&
		   sy >= -0x800 && sy <= 0x7ff)
		{
			//gteCoords[sy + 0x800][sx + 0x800][0] = fx / 65536.0f;
			//gteCoords[sy + 0x800][sx + 0x800][1] = fy / 65536.0f;
                        *(gteCoords+(sy+0x800)*(sx+0x800)) = fx / 65536.0f;
                        *(gteCoords+(sy+0x800)*(sx+0x800)+1) = fy / 65536.0f;
		}
	}
}

void resetGteVertices()
{
	if((bGteAccuracy)&&(!bGteAccuracyError))
	{
                gteCoords = (float*)malloc(0x800*2*sizeof(float)*0x800*2*2);
                if (gteCoords == NULL) { bGteAccuracyError = 1; bGteAccuracy = 0; return; }
		memset(gteCoords, 0x00, 0x800*2*sizeof(float)*0x800*2*2);
	}
}

void closeGteVertices()
{
        if((bGteAccuracy)&&(!bGteAccuracyError))
        {
                bGteAccuracy = 0;
                if (gteCoords != NULL) free(gteCoords);
                gteCoords = NULL;
        }
}

int getGteVertex(short sx, short sy, float *fx, float *fy)
{
                if(sx >= -0x800 && sx <= 0x7ff &&
                   sy >= -0x800 && sy <= 0x7ff)
                {
//                        if((fabsf(gteCoords[sy + 0x800][sx + 0x800][0] - sx) < 1.0) &&
//                           (fabsf(gteCoords[sy + 0x800][sx + 0x800][1] - sy) < 1.0))
                        if((fabsf( *(gteCoords+(sy+0x800)*(sx+0x800)) - sx) < 1.0) &&
                           (fabsf( *(gteCoords+(sy+0x800)*(sx+0x800)+1)- sy) < 1.0))
                        {
//                                *fx = gteCoords[sy + 0x800][sx + 0x800][0];
//                                *fy = gteCoords[sy + 0x800][sx + 0x800][1];
                                *fx = *(gteCoords+(sy+0x800)*(sx+0x800));
                                *fy = *(gteCoords+(sy+0x800)*(sx+0x800)+1);

                                return 1;
                        }
                }
	
	        return 0;
}
